> For the complete documentation index, see [llms.txt](https://docs.payengine.co/developer-docs/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.payengine.co/developer-docs/getting-started-1/8.-handling-callbacks-from-web-components.md).

# 8. Handling Callbacks from Web-Components

The `pay-engine` web-component is a DOM element that provides various events to which you can attach listeners to in your client side code. For specific events, please refer to following document:

* [Onboarding web-component](https://docs.payengine.co/developer-docs/getting-started-1/pages/-MTHswR5G-dPad8clHO2#3.-events)

To attach an event handler to web-component, you'll need to call `addEventListener` on your desired web-component element.

```
<pay-engine id="onboarding" merchant-id="ea0e0ae6-aa42-48da-b801-0106facf1e37" type="boarding"></pay-engine>

<script type="application/javascript">
    document.getElementById('onboarding').addEventListener('stepChange', function(e) {
        console.log(e.detail)
    })
    document.getElementById('onboarding').addEventListener('submitted', function(e) {
        console.log(e.detail)
    })
</script>
```

Below you'll find some equivalent examples in other popular frameworks.

## React

```
function MyComponent() {

    const addEvents = useCallback(node => {
        if (node !== null) {
            node.addEventListener('stepChange', function(e) {
                console.log('step changed', e.detail);
            })
        }
    });
    
    return <pay-engine 
        ref={addEvents} 
        merchant-id="ea0e0ae6-aa42-48da-b801-0106facf1e37" 
        type="boarding"></pay-engine>
}
```

## VueJS

```
<template>
    <pay-engine
        @step-change="stepChange"
        merchant-id="ea0e0ae6-aa42-48da-b801-0106facf1e37" 
        type="boarding"></pay-engine>
</template>

<script>
export default {
    methods: {
        stepChange(event) {
            console.log('step changed', event);
        }
    }
}
</script>
```

## Angular

```
// onboarding.component.html
<pay-engine
        (stepChange)="stepChange"
        merchant-id="ea0e0ae6-aa42-48da-b801-0106facf1e37" 
        type="boarding"></pay-engine>
        
// onboarding.component.ts
export class OnboardingComponent implements OnInit {
        onInit(): void {
        
        }
        
        stepChange(event: any) {
                console.log('step changed', event);
        }
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.payengine.co/developer-docs/getting-started-1/8.-handling-callbacks-from-web-components.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
